/**
 *closure for Bootstrap 5 Switches with central switch, left and right are modes
 *updates the hint-text
 *
 **/


/**settigns must contain
 *	parent				jQuery Object	
 *	id					the id
 *	onChange			click event listener with one string parameter
 *	isclicked			string value if checkbox is clicked
 *	notclicked			string value if checkbox is not clicked
	[isClickedLabel]		an optional label that is shown when the switch is clicked, overwriting isclicked
	[notClickedLabel]		an optional label that is shown when the switch is not clicked,overwriting notclicked
 *
 **/
function createSwitchCentral(settings)
{
	var mContainer;
	var mCheckbox;
	var mHint;
	var mLabelNotclicked;
	var mLabelClicked;
	var mDivSwitch;
	
	var mLastValue;
	
	inflate();
	setup();
	setupCSS();
	updateLabel();
	
	function inflate()
	{
		
		mContainer=$("<div/>");
		settings.parent.append(mContainer);
		
		
		mLabelNotclicked=$("<div/>").addClass("").text(settings.notclicked);
		mLabelClicked=$("<div/>").addClass("").text(settings.isclicked);
		//mContainer.append(mLabelClicked) //is not working bootstrap-5-checkbox
		
		mDivSwitch=$("<span/>").addClass("form-check form-switch");
		mContainer.append(mDivSwitch);
		
		
		
		mCheckbox=$("<input/>").attr("type","checkbox").addClass("form-check-input").attr("id",settings.id);
		mDivSwitch.append(mCheckbox);
		mHint=$("<label/>").addClass("form-check-label").attr("for",settings.id);//.text(settings.notclicked);
		mHint.append(mLabelClicked);
		mHint.append(mLabelNotclicked);
		
		//mHint.append(mCheckbox);
		mDivSwitch.append(mHint);
		
	}
	
	function setup(){
		mCheckbox.on("click",onClick);
		if (mCheckbox.is(":checked"))mLastValue=settings.isclicked;else mLastValue=settings.notclicked;
		//mLabelClicked.on("click",onHintPrefixClick);//the label behind the switch is controlled by bootstrap/browser
		
		
		//set visible label
		if (settings.isClickedLabel!=undefined)
		{			
			//mHint.text(settings.isClickedLabel);
		}else
		{
			//mHint.text(settings.isclicked);
		}
		
		if (settings.notClickedLabel!=undefined)
		{
			//mLabelClicked.text(settings.notClickedLabel);			
		}else
		{
			//mLabelClicked.text(settings.notclicked);
		}
			
		
		
	}
	
	function setupCSS()
	{
		//mContainer.css("user-select","none");
		mDivSwitch.css("cursor","pointer");
		mCheckbox.css("cursor","pointer");
		mHint.css("cursor","pointer");
		mHint.addClass("parametervalue");
		mLabelClicked.addClass("parameter");
		//mLabelNotclicked.addClass("parameter");
		mLabelClicked.css("margin-right","6px");				
		mLabelClicked.css("font-weight","600");//default is not clicked		
		mLabelNotclicked.css("margin-right","6px");
	}
	
	//user clicks on dropdown entry
	function onClick()
	{
		updateLabel();
		
		
		if (settings.onChange!=undefined)
		{
			if (mCheckbox.is(":checked"))
			{
				settings.onChange(settings.isclicked);
			}else
			{
				settings.onChange(settings.notclicked);
			}
		}		
	}
	
	function onHintPrefixClick()
	{
		console.log("prefix");
		setValue(settings.notclicked);
	}
	
	
	
	function updateLabel()
	{
		 if (mCheckbox.is(":checked"))
		 {
			mLastValue=settings.isclicked;
			//mHint.css("font-weight","600");
			mLabelClicked.css("font-weight","600");		
			mLabelClicked.css("text-decoration","");
			mLabelNotclicked.css("font-weight","300");		
			mLabelNotclicked.css("text-decoration","line-through");
			
			mHint.prepend(mLabelClicked);
			
			
			mLabelClicked.removeClass("note fs-6");
			mLabelNotclicked.addClass("note fs-6");
			
		 }else
		 {
			mLastValue=settings.notclicked;			
			//mHint.css("font-weight","300");
			mLabelClicked.css("font-weight","300");	
			mLabelClicked.css("text-decoration","line-through");
			mLabelNotclicked.css("font-weight","600");	
			mLabelNotclicked.css("text-decoration","");	
			
			mHint.prepend(mLabelNotclicked);
			mLabelNotclicked.removeClass("note fs-6");
			mLabelClicked.addClass("note fs-6");
		 }
	}
	
	
	
	
	//public methods
	
	function show()
	{
		mContainer.show();
	}
	
	function hide()
	{
		mContainer.hide();
	}
	
	
	function getValue()
	{
		return mLastValue.trim();
	}
	
	function setValue(aValue)
	{
		if (aValue==settings.isclicked)
		{
			mCheckbox.prop("checked",true);
		}
		
		if (aValue==settings.notclicked)
		{
			mCheckbox.prop("checked",false);
		}
		updateLabel();
	}
	
	function isChecked()
	{
		return mCheckbox.prop("checked");
	}
	
	return {		
		"getValue":getValue, //get the value of the button
		"isChecked":isChecked,
		"hide":hide,
		"show":show,
		"setValue":setValue
	};
}