/* closure to warp a text input

settings contains	
	parent: jQuery OBject where the content is injected
	id
	type
	title
	[placeholder]
	hint
*/

function createTextInput(settings)
{
	var mContainer;
	var mLabel;
	var mInput;
	var mHint;
	
	inflate();
	function inflate()
	{
		mContainer=$("<div/>").addClass("mb-3");
		settings.parent.append(mContainer);
		
		mLabel=$("<label/>").attr("for",settings.id).addClass("form-label");
		mLabel.text(settings.title);
		mContainer.append(mLabel);
		
		mInput=$("<input/>").attr("type",settings.type).addClass("form-control");
		mInput.attr("id",settings.id);
		if (settings.placeholder)
		{
			mInput.attr("placeholder",settings.placeholder);
		}
		mContainer.append(mInput);
		
		mHint=$("<small/>").addClass("text-muted form-text");
		mHint.text(settings.hint);
		mContainer.append(mHint);		
	}
	
	function getValue()
	{
		return mInput.val();
	}
	
	function setHint(aText,aClass)
	{
		mHint.text(aText);
		mHint.removeClass();
		mHint.addClass(aClass);
	}
	
	return {
		"getValue":getValue,
		"setHint":setHint
	}
	
	
	
	
}